/*-----------------------------------------------------------------------------
[]	CommonSettingDlg.cpp
[Tv]	^uy[Wʐݒ_CAO̎
[l]	Ȃ
[]	2004-03-31	NC		VK쐬(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "offlinepnger.h"
#include "CommonSettingDlg.h"
#include "pnger.h"
#include "common.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCommonSettingDlg _CAO


CCommonSettingDlg::CCommonSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCommonSettingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCommonSettingDlg)
	m_strSepalaterStart1 = _T("");
	m_strSepalaterStart2 = _T("");
	m_strSepalaterStart3 = _T("");
	m_strSepalaterEnd1 = _T("");
	m_strSepalaterEnd2 = _T("");
	m_strSepalaterEnd3 = _T("");
	m_iCode = -1;
	m_bBackup = FALSE;
	//}}AFX_DATA_INIT
}


void CCommonSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommonSettingDlg)
	DDX_Text(pDX, IDC_SEPARATER_START1, m_strSepalaterStart1);
	DDX_Text(pDX, IDC_SEPARATER_START2, m_strSepalaterStart2);
	DDX_Text(pDX, IDC_SEPARATER_START3, m_strSepalaterStart3);
	DDX_Text(pDX, IDC_SEPARATER_END1, m_strSepalaterEnd1);
	DDX_Text(pDX, IDC_SEPARATER_END2, m_strSepalaterEnd2);
	DDX_Text(pDX, IDC_SEPARATER_END3, m_strSepalaterEnd3);
	DDX_Radio(pDX, IDC_CODE_SHIFTJIS, m_iCode);
	DDX_Check(pDX, IDC_BACKUP, m_bBackup);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommonSettingDlg, CDialog)
	//{{AFX_MSG_MAP(CCommonSettingDlg)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommonSettingDlg bZ[W nh

void CCommonSettingDlg::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
}

BOOL CCommonSettingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Rg[̏
	m_strSepalaterStart1 = _T("<dd>");
	m_strSepalaterStart2 = _T("");
	m_strSepalaterStart3 = _T("");
	m_strSepalaterEnd1 = _T("\\n");
	m_strSepalaterEnd2 = _T("<dt>");
	m_strSepalaterEnd3 = _T("</dl>");
	m_bBackup = TRUE;
	m_iCode = (int)CodeShiftJis;
	UpdateData( FALSE );
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/*-----------------------------------------------------------------------------
[]	ݒ̓ǂݍ
[@\]	t@CݒǂݍŃRg[ɔfB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CCommonSettingDlg::Read(
	CString strIniFilePathName,		// <I> ݒt@CpX [-] (-) :-
	CString strSection				// <I> ۑZNV [-] (-) :-
)
{
	BOOL		bSuccess;
	CString		strValue;

	bSuccess = ReadProfile( strIniFilePathName, strSection, "strSepalaterStart1", &strValue );
	if ( bSuccess ){ m_strSepalaterStart1 = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "strSepalaterStart2", &strValue );
	if ( bSuccess ){ m_strSepalaterStart2 = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "strSepalaterStart3", &strValue );
	if ( bSuccess ){ m_strSepalaterStart3 = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "strSepalaterEnd1", &strValue );
	if ( bSuccess ){ m_strSepalaterEnd1 = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "strSepalaterEnd2", &strValue );
	if ( bSuccess ){ m_strSepalaterEnd2 = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "strSepalaterEnd3", &strValue );
	if ( bSuccess ){ m_strSepalaterEnd3 = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "bBackup", &strValue );
	if ( bSuccess ){ m_bBackup = StringToBool( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "iCode", &strValue );
	if ( bSuccess ){ m_iCode = StringToLong( strValue ); }

	UpdateData( FALSE );
}

/*-----------------------------------------------------------------------------
[]	ݒ̕ۑ
[@\]	Rg[̐ݒet@C֐ݒoB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CCommonSettingDlg::Write(
	CString strIniFilePathName,		// <I> ݒt@CpX [-] (-) :-
	CString strSection				// <I> ۑZNV [-] (-) :-
)
{
	UpdateData( TRUE );

	BOOL	bSuccess( TRUE );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strSepalaterStart1",	QuoteString( m_strSepalaterStart1 ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strSepalaterStart2",	QuoteString( m_strSepalaterStart2 ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strSepalaterStart3",	QuoteString( m_strSepalaterStart3 ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strSepalaterEnd1",	QuoteString( m_strSepalaterEnd1 ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strSepalaterEnd2",	QuoteString( m_strSepalaterEnd2 ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strSepalaterEnd3",	QuoteString( m_strSepalaterEnd3 ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "bBackup",			BoolToString( m_bBackup ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "iCode",				LongToString( m_iCode ) );
}


