/*-----------------------------------------------------------------------------
[]	TargetFolderPageDlg.cpp
[Tv]	tH_^ũ^uy[Wp_CAO̎
[l]	Ȃ
[]	2004-03-31 NC		VK쐬(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "TargetFolderPageDlg.h"
#include "common.h"
#include "OfflinepngerDlg.h"
#include "Pnger.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//-----------------------------------------------------------------------------
// 萔
//-----------------------------------------------------------------------------
// s
const char	strCRLF[] = { 0x0D, 0x0A, 0x00 };


/*-----------------------------------------------------------------------------
[]	Xbhp[^
[pr]	PNGXbhɓnp[^B
[l]	Ȃ
-----------------------------------------------------------------------------*/
struct TFolderThreadParam
{
	CString			strSrcFolder;			// ΏۃtH_
	CString			strFileFilter;			// Ώۃt@CtB^
	BOOL			bSubFolder;				// TutH_邩H
	BOOL			bBackup;				// IWiۑ邩H
	TGoPngParam		tGoPngParam;			// Pngp[^
};

/////////////////////////////////////////////////////////////////////////////
// CTargetFolderPageDlg _CAO


CTargetFolderPageDlg::CTargetFolderPageDlg(CWnd* pParent /*=NULL*/)
	: COwnerTabPage(CTargetFolderPageDlg::IDD, pParent)
	, m_pParent( NULL )
{
	//{{AFX_DATA_INIT(CTargetFolderPageDlg)
	m_strSrcFilePath = _T("");
	m_bSubFolder = FALSE;
	m_strFileFilter = _T("");
	//}}AFX_DATA_INIT
}


void CTargetFolderPageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTargetFolderPageDlg)
	DDX_Text(pDX, IDC_SRC_FILEPATH, m_strSrcFilePath);
	DDX_Check(pDX, IDC_SUBFOLDER, m_bSubFolder);
	DDX_Text(pDX, IDC_FILE_FILTER, m_strFileFilter);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTargetFolderPageDlg, CDialog)
	//{{AFX_MSG_MAP(CTargetFolderPageDlg)
	ON_BN_CLICKED(IDC_SRC_FILE_REF, OnSrcFileRef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTargetFolderPageDlg bZ[W nh

BOOL CTargetFolderPageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// _CAO\
	m_CommonSettingDlg.Create( IDD_COMMON_SETTING, this );
	m_CommonSettingDlg.ShowWindow( SW_SHOW );	

	m_strFileFilter = _T("*.htm");
	m_bSubFolder = TRUE;

	UpdateData( FALSE );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


/*-----------------------------------------------------------------------------
[]	tH_Qƃ{^nh
[@\]	ΏۃtH_̎wsB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CTargetFolderPageDlg::OnSrcFileRef() 
{
	UpdateData( TRUE );

	char	szPath[ _MAX_PATH ];
	BOOL	bDecided = ::SelectFolder(
		m_hWnd,
		NULL,
		szPath
	);
	if ( bDecided )
	{
		m_strSrcFilePath = szPath;
		UpdateData( FALSE );
	}
}


/*-----------------------------------------------------------------------------
[]	PNG摜Xbh
[@\]	PNG摜̐B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
static UINT GoPngThread(
	LPVOID pThreadParam		// <I> Xbhp[^ [-] (-) :-
)
{
	// PNG摜
	TFolderThreadParam*	pParam = (TFolderThreadParam*)pThreadParam;
	if ( pParam->tGoPngParam.pProgressDlg != NULL )
	{
		::FolderProcess(
			pParam->strSrcFolder,
			pParam->strFileFilter,
			pParam->bSubFolder,
			pParam->bBackup,
			&(pParam->tGoPngParam)
		);

		// i_CAOւ̊ʒm
		pParam->tGoPngParam.pProgressDlg->NotifyComplete();
	}

	return( 0 );
}


/*-----------------------------------------------------------------------------
[]	[PNG摜]{^nh
[@\]	PNG摜̊JnB
[ߒl]	Ȃ
[l]	Xbh𗧂āAI܂ő҂B
		i_CAOgpB
-----------------------------------------------------------------------------*/
void CTargetFolderPageDlg::GoPng() 
{
	COfflinepngerDlg*	pParent = m_pParent;

	m_CommonSettingDlg.UpdateData( TRUE );
	UpdateData( TRUE );

	CStringArray	astrSepalaterStartz;
	astrSepalaterStartz.Add( m_CommonSettingDlg.m_strSepalaterStart1 );
	astrSepalaterStartz.Add( m_CommonSettingDlg.m_strSepalaterStart2 );
	astrSepalaterStartz.Add( m_CommonSettingDlg.m_strSepalaterStart3 );
	CStringArray	astrSepalaterEndz;
	astrSepalaterEndz.Add( m_CommonSettingDlg.m_strSepalaterEnd1 );
	astrSepalaterEndz.Add( m_CommonSettingDlg.m_strSepalaterEnd2 );
	astrSepalaterEndz.Add( m_CommonSettingDlg.m_strSepalaterEnd3 );

	// s̓ǂݑւ
	long idxItem( 0 );
	for( idxItem=0 ; idxItem<astrSepalaterStartz.GetSize() ; idxItem++ )
	{
		astrSepalaterStartz[idxItem].Replace( _T("\\n"), strCRLF );
	}
	for( idxItem=0 ; idxItem<astrSepalaterEndz.GetSize() ; idxItem++ )
	{
		astrSepalaterEndz[idxItem].Replace( _T("\\n"), strCRLF );
	}

	pParent->m_btnGoPng.EnableWindow( FALSE );
	pParent->m_btnGoPng.SetWindowText( _T("イBBB") );

	pParent->m_ProgressDlg.Run();
	pParent->m_ProgressDlg.Show();

	// tH_
	TFolderThreadParam	tParam;
	tParam.strSrcFolder			= m_strSrcFilePath;
	tParam.strSrcFolder.TrimRight('\\');
	tParam.strFileFilter		= m_strFileFilter;
	tParam.bSubFolder			= m_bSubFolder;
	tParam.bBackup				= m_CommonSettingDlg.m_bBackup;

	tParam.tGoPngParam.pProgressDlg				= &(pParent->m_ProgressDlg);
	tParam.tGoPngParam.pastrSepalaterStartz		= &astrSepalaterStartz;
	tParam.tGoPngParam.pastrSepalaterEndz		= &astrSepalaterEndz;
	tParam.tGoPngParam.eCode					= (ECharCode)m_CommonSettingDlg.m_iCode;
	tParam.tGoPngParam.colFore					= pParent->m_colFore;
	tParam.tGoPngParam.colBack					= pParent->m_colBack;
	tParam.tGoPngParam.iMargin					= pParent->m_iMargin;
	tParam.tGoPngParam.bSpace					= pParent->m_bSpace;
	::AfxBeginThread( GoPngThread, &tParam );
	while( pParent->m_ProgressDlg.IsRunnning() )
	{
		MSG	msg;
		if(::PeekMessage(&msg,NULL,0,0,PM_REMOVE))
        {
              ::TranslateMessage(&msg);
              DispatchMessage(&msg);
        }
	}
	pParent->m_ProgressDlg.Hide();

	pParent->m_btnGoPng.SetWindowText( _T("PNG摜") );
	pParent->m_btnGoPng.EnableWindow( TRUE );
}


/*-----------------------------------------------------------------------------
[]	ݒ̓ǂݍ
[@\]	t@CݒǂݍŃRg[ɔfB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CTargetFolderPageDlg::Read(
	CString strIniFilePathName		// <I> ݒt@CpX [-] (-) :-
)
{
	CString	strSection( _T("TargetFolderPage") );
	BOOL		bSuccess;
	CString		strValue;

	bSuccess = ReadProfile( strIniFilePathName, strSection, "strFileFilter", &strValue );
	if ( bSuccess ){ m_strFileFilter = DeQuoteString( strValue ); }
	bSuccess = ReadProfile( strIniFilePathName, strSection, "bSubFolder", &strValue );
	if ( bSuccess ){ m_bSubFolder = StringToBool( strValue ); }

	m_CommonSettingDlg.Read( strIniFilePathName, strSection );

	UpdateData( FALSE );
}


/*-----------------------------------------------------------------------------
[]	ݒ̕ۑ
[@\]	Rg[̐ݒet@C֐ݒoB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CTargetFolderPageDlg::Write(
	CString strIniFilePathName		// <I> ݒt@CpX [-] (-) :-
)
{
	UpdateData( TRUE );

	CString	strSection( _T("TargetFolderPage") );
	BOOL	bSuccess( TRUE );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "strFileFilter",	QuoteString( m_strFileFilter ) );
	bSuccess &= WriteProfile( strIniFilePathName, strSection, "bSubFolder",		BoolToString( m_bSubFolder ) );

	m_CommonSettingDlg.Write( strIniFilePathName, strSection );
}


