/*-----------------------------------------------------------------------------
[]	common.cpp
[Tv]	򖖂Ȋ֐̎
[l]	Ȃ
[]	2004-02-23	NC		VK쐬(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#define Common
#include "Common.h"
#include <direct.h>


/*-----------------------------------------------------------------------------
[]	\[X擾
[@\]	\[X擾B
[ߒl]	CString		-	\[X [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CString	GetString(
	long	lStringID	// <I> \[XID [-] (-) :-
)
{
	CString	str;
	str.LoadString( lStringID );
	return( str );
}


/*-----------------------------------------------------------------------------
[]	pX擾
[@\]	pXpX擾B
[ߒl]	CString		-	pX [\] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CString		PathFromPathName(
	const CString&	strPathName	// <I> pX [-] (-) :-
)
{
	int	idxLastSlash = strPathName.ReverseFind( '\\' );
	return( strPathName.Left( idxLastSlash ) );
}


/*-----------------------------------------------------------------------------
[]	t@C^Cg擾
[@\]	pXt@C^Cg擾B
[ߒl]	CString		-	t@C^Cg [-] (-)
[l]	t@C^Cg͊gq̂Ȃt@CB
-----------------------------------------------------------------------------*/
CString		FilenameFromPathName(
	const CString&	strPathName	// <I> pX [-] (-) :-
)
{
	int	idxLastSlash = strPathName.ReverseFind( '\\' );
	int	idxLastDot = strPathName.ReverseFind( '.' );
	return( strPathName.Mid( idxLastSlash+1, idxLastDot-idxLastSlash-1 ) );
}


/*-----------------------------------------------------------------------------
[]	gq擾
[@\]	pXgq擾B
[ߒl]	CString		-	gq [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CString		ExtFromPathName(
	const CString&	strPathName	// <I> pX [-] (-) :-
)
{
	int	idxLastDot = strPathName.ReverseFind( '.' );
	return( strPathName.Mid( idxLastDot+1 ) );
}


/*-----------------------------------------------------------------------------
[]	tH_擾
[@\]	pXŉw̃tH_擾B
[ߒl]	CString		-	tH_ [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CString		FolderFromPath(
	const CString&	strPathName	// <I> pX [-] (-) :-
)
{
	int	idxLastSlash = strPathName.ReverseFind( '\\' );
	return( strPathName.Mid( idxLastSlash+1, strPathName.GetLength()-idxLastSlash-1 ) );
}


/*-----------------------------------------------------------------------------
[]	tH_\z
[@\]	wtH_݂ȂΐVɍB
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	PKwΉĂȂB
-----------------------------------------------------------------------------*/
BOOL	PrepareFolder(
	const CString&	strFolderName	// <I> tH_ [-] (-) :-
)
{
	if( strFolderName.IsEmpty() )
	{
		return( FALSE );
	}

	// ݊mF
	CFileStatus		tStatus;
	BOOL	bExists = CFile::GetStatus(
		strFolderName,
		tStatus
	);
	if ( bExists )
	{
		if ( (tStatus.m_attribute | 0x10) == 0 )
		{
			// ̃t@C݂
			return FALSE;
		}
	}
	else
	{
		// tH_̍쐬
		if ( _mkdir( strFolderName ) != 0 )
		{
			// G[
			return( FALSE );
		}
	}

	return( TRUE );
}


/*-----------------------------------------------------------------------------
[]	tH_擾_CAO R[obN֐
[@\]	
[ߒl]	
[l]	SHBrowseForFolder ̃wvQƁB
-----------------------------------------------------------------------------*/ 
int CALLBACK BrowseCallbackProc( 
	HWND hwnd,				// _CAO{bNX̃nh
	UINT uMsg,				// Cxgʂl
	LPARAM lParam,			// uMsg Ɉˑl
	LPARAM lpData			// AvP[V`l
)
{
	//@̃tH_I
	if(uMsg == BFFM_INITIALIZED)
	{
       if(lpData != NULL)
	   {
            SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);
	   }
    }
	return 0;
}


/*-----------------------------------------------------------------------------
[]	tH_w
[@\]	tH_擾_CAOJtH_擾
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/ 
BOOL SelectFolder ( 
	HWND hWnd,					// <I> Parent [-] (-) :-
	LPCTSTR lpDefFolder,		// <I> ItH_l [-] (-) :-
	LPTSTR lpSelectPath			// <O> ItH_̊i[ [-] (-) :-
)
{
	LPMALLOC	pMalloc;
	BOOL		rslt = FALSE;

	//@IMallocC^[tFCXւ̃|C^擾
	if (SUCCEEDED(SHGetMalloc(&pMalloc)))
	{
		BROWSEINFO		brows;
		ITEMIDLIST		*pIDlist;

		//@\̂̏ 
		memset ( &brows, NULL, sizeof(brows));
		brows.hwndOwner			= hWnd;
		brows.pszDisplayName	= lpSelectPath;
		brows.lpszTitle			= "tH_[IĂ";
		brows.lpfn				= (BFFCALLBACK)BrowseCallbackProc;
		brows.lParam			= (LPARAM)lpDefFolder;

		//	tH_[I_CAO̕\
		pIDlist = SHBrowseForFolder( &brows);

		if( pIDlist == NULL)
		{
			strcpy( lpSelectPath, "");
		}
		else 
		{
			// ITEMIDLIST tpX𓾂
			SHGetPathFromIDList( pIDlist, lpSelectPath);
			rslt	= TRUE;

			//ITEMIDLIST ̊J
			pMalloc -> Free( pIDlist);
		}

		pMalloc -> Release();
	}

	return	rslt;
}


/*-----------------------------------------------------------------------------
[]	ʔ֐
[@\]	[hoCgɂ镶픻fBiJISAShift-JISʁj
[ߒl]	BOOL	f [-] (TRUE:AFALSE:)
[l]	Ȃ
-----------------------------------------------------------------------------*/ 
// PoCgڂJ^Jiۂ𔻒f(JIS)
BOOL IsJIS_Kana(BYTE ch)
{
    return ch == 0x8e ? TRUE:FALSE;
}

// PoCgڂۂ𔻒f(JIS)
BOOL IsJIS_Kanji(BYTE ch)
{
    return (ch >=0x21 && ch <=0x7e) ? TRUE:FALSE;
}

// PoCgڂۂ𔻒f(Shift-JIS)
BOOL IsSJIS_Kanji(BYTE ch)
{
    // 0x81 - 0x9F  0xE0 - 0xFC ͈̔
    return _ismbblead( (WORD)ch) != 0 ? TRUE:FALSE;
}

// PoCgڂpJ^Jiۂ𔻒f(Shift-JIS)
BOOL IsSJIS_Kana(BYTE ch)
{
    // 0xA1 - 0xDF ͈̔
    return _ismbbkana( (WORD)ch) != 0 ? TRUE:FALSE;
}


/*-----------------------------------------------------------------------------
[]	EUC -> SHIFT-JISϊ
[@\]	EUCSHIFT-JISɕϊB
[ߒl]	BOOL	Shift-JIS [-] (-)
[l]	http://www.athomejp.com/goldfish/mfc/original/euctosjis.asp
-----------------------------------------------------------------------------*/ 
CString EUCtoSJIS(
	const CString& str		// <I> EUC [EUC] (-) :-
)
{
	const BYTE*	strSrc = (BYTE*)((LPCTSTR)str);
	BYTE*	strDst = new BYTE[str.GetLength()*2+1];
	long	idxDst( 0 );
	for( long idxSrc=0; idxSrc<str.GetLength() ; idxSrc++ )
	{
		BYTE	ch1 = strSrc[idxSrc];
		// PoCgڂpJ^Jȉꍇ
		if( IsJIS_Kana( ch1 ) == TRUE )
		{
			// PoCgڂ͎̂Ă
			idxSrc++;
			strDst[idxDst++] = strSrc[idxSrc];
		}
		// PoCgڂ̏ꍇ(0x21`0x7E)
		else if( IsJIS_Kanji( ch1 ^ 0x80 ) == TRUE )
		{
			idxSrc++;
			ch1 ^= 0x80;
			BYTE ch2 = strSrc[idxSrc] ^ 0x80;
			WORD wcode = MAKEWORD( ch2, ch1 );
			wcode = _mbcjistojms( wcode );
			strDst[idxDst++] = HIBYTE( wcode );
			strDst[idxDst++] = LOBYTE( wcode );
		}
		else
		{
			strDst[idxDst++] = ch1;
		}
	}
	strDst[idxDst] = 0x00;
	CString		strResult(strDst);
	delete [] strDst;
	return strResult;
}


/*-----------------------------------------------------------------------------
[]	SHIFT-JIS -> EUCϊ
[@\]	SHIFT-JISEUCɕϊB
[ߒl]	BOOL	EUC [-] (-)
[l]	http://www.athomejp.com/goldfish/mfc/original/sjistoeuc.asp
-----------------------------------------------------------------------------*/ 
CString SJIStoEUC(
	const CString& str		// <I> SHIFT-JIS [SHIFT-JIS] (-) :-
)
{
	const BYTE*	strSrc = (BYTE*)((LPCTSTR)str);
	BYTE*	strDst = new BYTE[str.GetLength()*2+1];
	long	idxDst( 0 );
	for( long idxSrc=0; idxSrc<str.GetLength() ; idxSrc++ )
    {
        BYTE ch1 = strSrc[idxSrc];
        // PoCgڂ̏ꍇ
        if( IsSJIS_Kanji( ch1 ) == TRUE)
        {
            idxSrc++;
            // Qڂ擾
            BYTE ch2 = strSrc[idxSrc];
        
            // Ƃ肠JISɕϊ
            DWORD wcode = MAKEWORD( ch2, ch1 );
            wcode = _mbcjmstojis( wcode );
            // ʂƉʂ0x80
            ch1 = HIBYTE( wcode ) | 0x80;
            ch2 = LOBYTE( wcode ) | 0x80;
            strDst[idxDst++] = ch1;
            strDst[idxDst++] = ch2;
        }
        // pJ^Jȉꍇ
        else if( IsSJIS_Kana( ch1 ) == TRUE)
        {
            // ʃrbg0x8E00t
            strDst[idxDst++] = (BYTE)0x8E;
            strDst[idxDst++] = ch1;
        }
        else
        {
            strDst[idxDst++] = ch1;
        }
    }
	strDst[idxDst] = 0x00;
	CString		strResult(strDst);
	delete [] strDst;
	return strResult;
}






CString	BoolToString(
	BOOL	bValue
)
{
	if( bValue )
	{
		return( "TRUE" );
	}
	else
	{
		return( "FALSE" );
	}
}

BOOL	StringToBool(
	CString	strValue
)
{
	strValue.MakeUpper();
	strValue.TrimLeft();
	strValue.TrimRight();
	if( strValue == "TRUE" )
	{
		return( TRUE );
	}
	else
	{
		return( FALSE );
	}
}


CString	LongToString(
	long	lValue
)
{
	CString	str;
	str.Format("%d", lValue);
	return( str );
}

long	StringToLong(
	CString	strValue
)
{
	return( atol( strValue ) );
}

CString	ColorrefToString(
	COLORREF	colValue
)
{
	CString	str;
	str.Format("#%06X", (int)colValue);
	return( str );
}

COLORREF	StringToColorref(
	CString		strValue
)
{
	int		iValue = 0;

	::sscanf( strValue, "#%06X", &iValue );
	return( (COLORREF)(iValue) );
}

CString	DeQuoteString(
	CString&	strValue
)
{
//	strValue.TrimLeft();
//	strValue.TrimRight();

	int		idxStart = strValue.Find( '\"' ) + 1;
	int		idxEnd = strValue.ReverseFind ( '\"' );

	if( idxStart>0 )
	if( idxEnd>0 )
	if( idxStart<=idxEnd )
	{
		strValue = strValue.Mid(
			idxStart,
			idxEnd - idxStart
		);
	}
	return( strValue );
}


CString	QuoteString(
	CString&	strValue
)
{
	CString	str;
	str.Format("\"%s\"", strValue);
	return( str );
}


BOOL WriteProfile(
	CString&			strFilename,
	const char*			strSection,
	const char*			strKey,
	const char*			strValue
)
{
	BOOL	bSuccess;
	bSuccess = WritePrivateProfileString(
		strSection,
		strKey,
		strValue,
		strFilename
	);

	return( bSuccess );
}


BOOL	ReadProfile(
	CString&			strFilename,
	const char*			strSection,
	const char*			strKey,
	CString*			pstrValue
)
{
	const 	PROFILE_LINE_SIZE = 512;
	char	aBuffer[ PROFILE_LINE_SIZE+1 ];
	aBuffer[ 0 ] = 0x00;
	BOOL	bSuccess = GetPrivateProfileString(
		strSection,
		strKey,
		"",
		aBuffer,
		PROFILE_LINE_SIZE,
		strFilename
	);
	*pstrValue = aBuffer;

	return( bSuccess );
}