/*-----------------------------------------------------------------------------
[]	Unicoder.h
[Tv]	jR[hǗNX̃wb_
[l]	Ȃ
[]	2003-02-27	NC		Rgt(moralog)
		2004-03-31 pnger	pngerpJX^}CY(moralog)
-----------------------------------------------------------------------------*/
#if !defined(AFX_UNICODER_H_INCLUDED_)
#define AFX_UNICODER_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "LogFont.h"


//-----------------------------------------------------------------------------
// 萔
//-----------------------------------------------------------------------------
const	int HTMLCHARCODE_LENGTH = (16);		// HTMLi[pobt@傫


/*-----------------------------------------------------------------------------
[]	jR[h\Ǘ
[pr]	jR[h̕\ɊւJvZB
[l]	Ȃ
-----------------------------------------------------------------------------*/
class CUnicoder  
{
public:
	// CX^X̎擾Ej
	static CUnicoder*	GetInstance();
	virtual ~CUnicoder();

// ϊ
	// UnicodeSJisϊij
	static long GetSJisString(
		const char*		pcstr,
		const wchar_t*	pwcstr,
		char*			pDst
	);

	// jR[h𕶎Shift-JisɕϊiPj
	static int		UnicodeToSJIS(
		const wchar_t	uniSrc,
		char*			sjisDst
	);


// Pϊ
	// jR[h𕶎ɕϊ
	int		UnicodeToCharCode(
		const wchar_t	uniSrc,
		char*			sjisDst
	);

	// jR[h̎QƂɕϊ
	static int		UnicodeToEntityRef(
		const wchar_t	uniSrc,
		char*			sjisDst
	);

// jR[h
	long		IsUnicode(
		const char*	pstrSrc,
		wchar_t*	pwcharUnicode
	);

// `
	// `
	void DrawCharCode(
		HDC				hdc,
		const RECT&		rcDst,
		wchar_t			tCharCode
	);

	// gp`vZ
	SIZE ExtextCharCode(
		HDC				hdc,
		wchar_t			tCharCode
	);

	// jR[hɑΉtHg擾
	HFONT GetFont(
		HDC			hdc,
		wchar_t		tCharCode
	);

	// HTMLLLݒE擾
	void SetEnable(
		BOOL	bEnable
	){ m_bEnable = bEnable; };
	BOOL GetEnable(){ return( m_bEnable ); };

	// `\mF
	BOOL	IsDrawable(
		HDC			hdc,
		HFONT		font,
		wchar_t		tCharCode
	);

protected:
	// jR[h𕶎Shift-Jisɕϊij
	static long	GetSJisStringCore(
		const char*		pcstr,
		const wchar_t*	pwcstr,
		char*			pDstBuffer
	);


	BOOL				m_bEnable;			// HTMLL [-] (TRUE:LAFALSE:)

private:
	// BꂽRXgN^
	CUnicoder();
};

#endif // !defined(AFX_UNICODER_H_INCLUDED_)
