/*-----------------------------------------------------------------------------
[]	savepng.cpp
[Tv]	libpnggpPNG摜ۑ̎
[l]	ǂŏE\[X́BǂŏÊOB
[]	2004-02-23	NC		VK쐬(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#define STRICT
#include <vector>
#include <windows.h>
#include "png.h"
using namespace std;


/*-----------------------------------------------------------------------------
[]	PNGo
[@\]	rbg}bvPNGƂďoB
[ߒl]	BOOL	-	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	SavePng(
	const HBITMAP hbmp,		// <I> Ώۃrbg}bv [-] (-) :-
	FILE* fp				// <O> o͐Xg[ [-] (-) :-
)
{
	png_structp png_ptr;
	png_infop info_ptr;

	if (fp == NULL) {
		return( FALSE );
	}

	png_ptr = png_create_write_struct(
		PNG_LIBPNG_VER_STRING,
		NULL, NULL, NULL
	);
	if (png_ptr == NULL) {
		return( FALSE );
	}

	info_ptr = png_create_info_struct(png_ptr);
	if (info_ptr == NULL) {
		png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
		return( FALSE );
	}

	if (setjmp(png_ptr->jmpbuf)) {
		png_destroy_info_struct( png_ptr, &info_ptr );
		png_destroy_write_struct(&png_ptr,	(png_infopp)NULL);
		return( FALSE );
	}

	/* ----- libpng ɃXg[n */
	png_init_io(png_ptr, fp);

	BITMAP		tBitmap;
	BITMAPINFO	tBitmapInfo;
	char*		pBitmapBits = NULL;
	{
		HDC hdc = ::GetDC( NULL );

			::GetObject( hbmp, sizeof(BITMAP), &tBitmap );
			
			// BITMAPINFO擾
			tBitmapInfo.bmiHeader.biSize = sizeof( BITMAPINFOHEADER );

            memset( &tBitmapInfo, 0, sizeof(tBitmapInfo) );

            tBitmapInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
            tBitmapInfo.bmiHeader.biWidth = tBitmap.bmWidth;
            tBitmapInfo.bmiHeader.biHeight = tBitmap.bmHeight;
            tBitmapInfo.bmiHeader.biPlanes = tBitmap.bmPlanes;
            tBitmapInfo.bmiHeader.biBitCount = 24;//tBitmap.bmBitsPixel;

			int iResult = ::GetDIBits(
				hdc,						// handle to device context
				hbmp,						// handle to bitmap
				0,
				1,							// number of scan lines to copy
				NULL,						// address of array for bitmap bits
				&tBitmapInfo,				// address of structure with bitmap data
				DIB_RGB_COLORS				// RGB or palette index
			);
			if ( iResult > 0 )
			{

				UINT		uiColorFlag;
				switch ( tBitmapInfo.bmiHeader.biBitCount )
				{
				case 1:
					uiColorFlag = DIB_PAL_COLORS;
					// ߂AΉBRGBQUADpӂ̂߂ǂB
					break;

				default:
					uiColorFlag = DIB_RGB_COLORS;
					break;
				}

				int		iWidth = tBitmapInfo.bmiHeader.biWidth;
				int		iHeight = tBitmapInfo.bmiHeader.biHeight;
				int		iDepth = tBitmapInfo.bmiHeader.biBitCount;

				long	nBit = tBitmapInfo.bmiHeader.biSizeImage;
				pBitmapBits = new char[ nBit + sizeof(BITMAPFILEHEADER) ];


				// BITMAPINFO擾
				iResult = ::GetDIBits(
					hdc,						// handle to device context
					hbmp,						// handle to bitmap
					0,
					tBitmapInfo.bmiHeader.biHeight,
					pBitmapBits,				// address of array for bitmap bits
					&tBitmapInfo,				// address of structure with bitmap data
					uiColorFlag					// RGB or palette index
				);
				if ( iResult == 0 )
				{
					delete [] pBitmapBits;
					pBitmapBits = NULL;
				}
			}

		::ReleaseDC( NULL, hdc );

			if ( iResult == 0 )
			{
				png_destroy_info_struct( png_ptr, &info_ptr );
				png_destroy_write_struct(&png_ptr,	(png_infopp)NULL);
				return( FALSE );
			}
	}

	/* ----- png ^Cv̐ݒ */
/*	if (gdk_pixbuf_get_has_alpha(pic) == TRUE) {
		png_set_IHDR(png_ptr, info_ptr,	
		 sizeBmp.cx,
		 sizeBmp.cy,
		 8,
		 PNG_COLOR_TYPE_RGB_ALPHA,
		 PNG_INTERLACE_NONE,
		 PNG_COMPRESSION_TYPE_BASE,
		 PNG_FILTER_TYPE_BASE);
	}
	else*/ {
		png_set_IHDR(png_ptr, info_ptr,	
		 tBitmap.bmWidth,
		 tBitmap.bmHeight,
		 8,
		 PNG_COLOR_TYPE_RGB,
		 PNG_INTERLACE_NONE,
		 PNG_COMPRESSION_TYPE_BASE,
		 PNG_FILTER_TYPE_BASE);
	}

	/* ----- CtH[Vwb_[o */
	png_write_info(png_ptr, info_ptr);

	/* ----- sNZo */
	{ 
		png_uint_32	idxLine;
		png_bytep *row_pointers;
		row_pointers = new png_bytep[ tBitmap.bmHeight ];
		for(idxLine=0; idxLine<tBitmap.bmHeight ; idxLine++)
		{
			row_pointers[ tBitmap.bmHeight - idxLine - 1] =
				(png_bytep)(pBitmapBits +
					( tBitmapInfo.bmiHeader.biWidth*tBitmapInfo.bmiHeader.biBitCount/8 * idxLine));
		}
		png_write_image(png_ptr, row_pointers);
		delete [] row_pointers;
	}
	delete [] pBitmapBits;


	/* ----- ȍIAn */
	png_write_end(png_ptr, info_ptr);
	png_destroy_info_struct( png_ptr, &info_ptr );
	png_destroy_write_struct( &png_ptr, (png_infopp)NULL);

	return( TRUE );
}

