/*-----------------------------------------------------------------------------
[]	TargetFilePageDlg.cpp
[Tv]	t@C^ũ^uy[Wp_CAO̎
[l]	Ȃ
[]	2004-03-31 NC		VK쐬(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "TargetFilePageDlg.h"
#include "common.h"
#include "OfflinepngerDlg.h"
#include "Pnger.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//-----------------------------------------------------------------------------
// 萔
//-----------------------------------------------------------------------------
// s
const char	strCRLF[] = { 0x0D, 0x0A, 0x00 };


/*-----------------------------------------------------------------------------
[]	Xbhp[^
[pr]	PNGXbhɓnp[^B
[l]	Ȃ
-----------------------------------------------------------------------------*/
struct TFileThreadParam
{
	CString			strSrcFilePathName;		// Ώۃt@C
	BOOL			bBackup;				// obNAbv邩H
	TGoPngParam		tGoPngParam;			// Pngp[^
};

/////////////////////////////////////////////////////////////////////////////
// CTargetFilePageDlg _CAO


CTargetFilePageDlg::CTargetFilePageDlg(CWnd* pParent /*=NULL*/)
	: COwnerTabPage(CTargetFilePageDlg::IDD, pParent)
	, m_pParent( NULL )
{
	//{{AFX_DATA_INIT(CTargetFilePageDlg)
	m_strSrcFilePath = _T("");
	//}}AFX_DATA_INIT
}


void CTargetFilePageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTargetFilePageDlg)
	DDX_Text(pDX, IDC_SRC_FILEPATH, m_strSrcFilePath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTargetFilePageDlg, CDialog)
	//{{AFX_MSG_MAP(CTargetFilePageDlg)
	ON_BN_CLICKED(IDC_SRC_FILE_REF, OnSrcFileRef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTargetFilePageDlg bZ[W nh

BOOL CTargetFilePageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// _CAO\
	m_CommonSettingDlg.Create( IDD_COMMON_SETTING, this );
	m_CommonSettingDlg.ShowWindow( SW_SHOW );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


/*-----------------------------------------------------------------------------
[]	t@CI[v{^nh
[@\]	Ώۃt@C̎wsB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CTargetFilePageDlg::OnSrcFileRef() 
{
//	UpdateData( TRUE );

	CFileDialog	dlg( TRUE );
	if ( dlg.DoModal() == IDOK )
	{
		m_strSrcFilePath = dlg.GetPathName();
		UpdateData( FALSE );
	}
}



/*-----------------------------------------------------------------------------
[]	PNG摜Xbh
[@\]	PNG摜̐B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
static UINT GoPngThread(
	LPVOID pThreadParam		// <I> Xbhp[^ [-] (-) :-
)
{
	TFileThreadParam*	pParam = (TFileThreadParam*)pThreadParam;
	if ( pParam->tGoPngParam.pProgressDlg != NULL )
	{
		// tH_
		CString		strPath = ::PathFromPathName( pParam->strSrcFilePathName );
		CString		strTitle = ::FilenameFromPathName( pParam->strSrcFilePathName );
		CString		strExt = ::ExtFromPathName( pParam->strSrcFilePathName );

		// t@CobNAbv
		if ( pParam->bBackup )
		{
			// ۑptH_쐬
			CString		strBackupPath;
			strBackupPath.Format( _T("%s\\backup"), strPath );
			::PrepareFolder( strBackupPath );

			// t@C擾
			CString strSrcFilePathName;
			strSrcFilePathName.Format( "%s\\%s.%s", strPath, strTitle, strExt );

			// ۑt@CpX
			CString	strCopyFilePathName;
			strCopyFilePathName.Format( "%s\\%s.%s", strBackupPath, strTitle, strExt );

			// t@C̃Rs[i㏑ۑj
			::CopyFile( strSrcFilePathName, strCopyFilePathName, TRUE );
		}

		// t@C̏
		{
			// t@C͂PNG
			::AnalizeHtml(
				pParam->strSrcFilePathName,
				&(pParam->tGoPngParam)
			);
		}

		// i_CAOւ̊ʒm
		pParam->tGoPngParam.pProgressDlg->NotifyComplete();
	}

	return( 0 );
}


/*-----------------------------------------------------------------------------
[]	[PNG摜]{^nh
[@\]	PNG摜̊JnB
[ߒl]	Ȃ
[l]	Xbh𗧂āAI܂ő҂B
		i_CAOgpB
-----------------------------------------------------------------------------*/
void CTargetFilePageDlg::GoPng() 
{
	COfflinepngerDlg*	pParent = m_pParent;

	m_CommonSettingDlg.UpdateData( TRUE );
	UpdateData( TRUE );

	CStringArray	astrSepalaterStartz;
	astrSepalaterStartz.Add( m_CommonSettingDlg.m_strSepalaterStart1 );
	astrSepalaterStartz.Add( m_CommonSettingDlg.m_strSepalaterStart2 );
	astrSepalaterStartz.Add( m_CommonSettingDlg.m_strSepalaterStart3 );
	CStringArray	astrSepalaterEndz;
	astrSepalaterEndz.Add( m_CommonSettingDlg.m_strSepalaterEnd1 );
	astrSepalaterEndz.Add( m_CommonSettingDlg.m_strSepalaterEnd2 );
	astrSepalaterEndz.Add( m_CommonSettingDlg.m_strSepalaterEnd3 );

	// s̓ǂݑւ
	long idxItem( 0 );
	for( idxItem=0 ; idxItem<astrSepalaterStartz.GetSize() ; idxItem++ )
	{
		astrSepalaterStartz[idxItem].Replace( _T("\\n"), strCRLF );
	}
	for( idxItem=0 ; idxItem<astrSepalaterEndz.GetSize() ; idxItem++ )
	{
		astrSepalaterEndz[idxItem].Replace( _T("\\n"), strCRLF );
	}

	pParent->m_btnGoPng.EnableWindow( FALSE );
	pParent->m_btnGoPng.SetWindowText( _T("イBBB") );

	pParent->m_ProgressDlg.Run();
	pParent->m_ProgressDlg.Show();

	// t@C
	TFileThreadParam	tParam;
	tParam.strSrcFilePathName = m_strSrcFilePath;
	tParam.bBackup				= m_CommonSettingDlg.m_bBackup;

	tParam.tGoPngParam.pastrSepalaterStartz	= &astrSepalaterStartz;
	tParam.tGoPngParam.pastrSepalaterEndz	= &astrSepalaterEndz;
	tParam.tGoPngParam.eCode				= (ECharCode)m_CommonSettingDlg.m_iCode;
	tParam.tGoPngParam.pProgressDlg			= &(pParent->m_ProgressDlg);
	tParam.tGoPngParam.colFore				= pParent->m_colFore;
	tParam.tGoPngParam.colBack				= pParent->m_colBack;
	tParam.tGoPngParam.iMargin				= pParent->m_iMargin;
	tParam.tGoPngParam.bSpace				= pParent->m_bSpace;

	::AfxBeginThread( GoPngThread, &tParam );
	while( pParent->m_ProgressDlg.IsRunnning() )
	{
		MSG	msg;
		if(::PeekMessage(&msg,NULL,0,0,PM_REMOVE))
        {
              ::TranslateMessage(&msg);
              DispatchMessage(&msg);
        }
	}
	pParent->m_ProgressDlg.Hide();

	pParent->m_btnGoPng.SetWindowText( _T("PNG摜") );
	pParent->m_btnGoPng.EnableWindow( TRUE );
}


/*-----------------------------------------------------------------------------
[]	ݒ̓ǂݍ
[@\]	t@CݒǂݍŃRg[ɔfB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CTargetFilePageDlg::Read(
	CString strIniFilePathName		// <I> ݒt@CpX [-] (-) :-
)
{
	CString	strSection( _T("TargetFilePage") );
	m_CommonSettingDlg.Read( strIniFilePathName, strSection );
	UpdateData( FALSE );
}


/*-----------------------------------------------------------------------------
[]	ݒ̕ۑ
[@\]	Rg[̐ݒet@C֐ݒoB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CTargetFilePageDlg::Write(
	CString strIniFilePathName		// <I> ݒt@CpX [-] (-) :-
)
{
	UpdateData( TRUE );
	CString	strSection( _T("TargetFilePage") );
	m_CommonSettingDlg.Write( strIniFilePathName, strSection );
}


