// pnger.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "../shared/stdafx.h"
#include <windows.h>
#include <string>
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include <locale.h>
using namespace std;
#include "../shared/savepng.h"
#include "../shared/pngercore.h"


#define	RELEASE_CGI
#define MAX_MARGIN	(100)




int parse_form(
	char* s_in,long maxl,char* name[],char* value[],int *p_nfld,
	int		iMaxOptionCount
)
{
        int i,cur_field;
        *p_nfld=0;
        i=0;
        cur_field=0;
        if(s_in[0]==NULL) return(-1);
        name[0]=s_in;
        while((s_in[++i]!=NULL)&&(i<maxl))
		{
			if(s_in[i]=='='){
					s_in[i]=NULL;
					value[cur_field]=s_in+i+1;
			}
			else if(s_in[i]=='&'){
					s_in[i]=NULL;
					cur_field++;
					name[cur_field]=s_in+i+1;
			}

			if ( cur_field >= iMaxOptionCount+1 )
			{
				break;
			}
        }
        *p_nfld=cur_field+1;
        return(0);
}
        
int decode_form(char* s,long len)
{
        int i,j;
        char buf,*s1;
        if(len==0)return(-1);
        s1=(char*)malloc(len);
        for(i=0,j=0;i<len;i++,j++)
        {
                if(s[i]=='+'){s1[j]=' ';continue;}
                if(s[i]!='%') {s1[j]=s[i];continue;}
                buf=((s[++i]>='A') ? s[i]-'A'+10 : s[i]-'0');
                buf*=16;
                buf+=((s[++i]>='A') ? s[i]-'A'+10 : s[i]-'0');
                s1[j]=buf;
        }
        for(i=0;i<j;i++) s[i]=s1[i];
        s[i]='\0';
        free(s1);
        return(0);
}


COLORREF	HexToLong(
	LPCTSTR	strCOLOR
)
{
	long	lLog( 10 );
	long	lNumeric( 0 );
	for( ; *strCOLOR != NULL ; strCOLOR++ )
	{
		if ( *strCOLOR == '#' )
		{
			// 擪 # ΂PUi
			if ( lNumeric == 0 )
			{
				lLog = 16;
				continue;
			}
			else
			{
				// rɂ̂Ȃ炻܂łŏI
				break;
			}
		}

		if ( (*strCOLOR>='0') && (*strCOLOR<='9') )
		{
			lNumeric *= lLog;
			lNumeric += ( *strCOLOR - '0' );
			continue;
		}

		if ( lLog == 16 )
		{
			if ( (*strCOLOR>='A') && (*strCOLOR<='F') )
			{
				lNumeric *= lLog;
				lNumeric += ( *strCOLOR - 'A' + 10 );
				continue;
			}

			if ( (*strCOLOR>='a') && (*strCOLOR<='f') )
			{
				lNumeric *= lLog;
				lNumeric += ( *strCOLOR - 'a' + 10 );
				continue;
			}
		}

		// Ȃ񂩂킩ȂĂ܂
		break;
	}
	return( lNumeric );
}


int main(int argc, char* argv[])
{
const int MAXOPTION = 10;
const int MAXLEN = 1024*10;


	setlocale( LC_ALL, "japanese" );

	// W͂͂
	{
		long	length( MAXLEN );

#ifdef RELEASE_CGI
		// ̓f[^̃TCY擾
		BOOL	bPost;
		{
			char*	cLength;
		    cLength=(char*)getenv("CONTENT_LENGTH");
			bPost = ( cLength != NULL );
			if ( bPost )
			{
		        length=atol(cLength);
			}
			else
			{
				length = strlen((char*)getenv("QUERY_STRING"));
			}
		}
        if ( length > MAXLEN )
		{
			// ̂͏Ȃ
			return(0);
		}
#endif 
		// 
		char*	inputstring;
        inputstring = new char[ length+1 ];

#ifdef RELEASE_CGI
		if ( bPost )
		{
	        scanf( "%s", inputstring );
		}
		else
		{
			strcpy(inputstring, (char*)getenv("QUERY_STRING"));
		}
#else
		strcpy( inputstring, "fore=#0000FF&back=#FF0000&aa=abcd<br>qwer" );
		length = strlen( inputstring );
#endif
		{
			char*	name[ MAXOPTION ];
			char*	value[ MAXOPTION ];
			int		nfield;
	        parse_form(
				inputstring,
				length,
				name,
				value,
				&nfield,
				MAXOPTION
			);

			int idxOption;

			// fR[h
			COLORREF	colFore( RGB( 0, 0, 0 ) );
			COLORREF	colBack( RGB( 255, 255, 255 ) );
			LPCTSTR		strSrcAA( NULL );
			BOOL		bLf( FALSE );
			int			iMargin( 0 );
			BOOL		bSpace( TRUE );
		    for( idxOption=0 ; idxOption<nfield ; idxOption++ )
			{
		        decode_form(
					value[idxOption],
					strlen(value[idxOption])
				);

				// Fw
				if ( strcmp( name[idxOption], "fore" ) == 0 )
				{
					colFore = HexToLong( value[idxOption] );
					continue;
				}
				if ( strcmp( name[idxOption], "back" ) == 0 )
				{
					colBack = HexToLong( value[idxOption] );
					continue;
				}
				// sf
				if ( strcmp( name[idxOption], "lf" ) == 0 )
				{
					bLf = ( value[idxOption] != 0 );
					continue;
				}
				// AA
				if ( strcmp( name[idxOption], "aa" ) == 0 )
				{
					strSrcAA = value[idxOption];
					continue;
				}
				// Margin
				if ( strcmp( name[idxOption], "margin" ) == 0 )
				{
					iMargin = HexToLong( value[idxOption] );
					iMargin = min( iMargin, MAX_MARGIN );
					continue;
				}
				// Space
				if ( strcmp( name[idxOption], "space" ) == 0 )
				{
					bSpace = !( value[idxOption] != 0 );
					continue;
				}
			}

			// PNG̍쐬
			{
#ifdef RELEASE_CGI
				FILE*	pFile =  stdout;
				_setmode( _fileno(stdout), _O_BINARY);
				printf("Content-type: text/html\n\n");
#else
				FILE*	pFile = fopen( "c:\\test.png", "wb");
#endif
				CreatePng(
					strSrcAA,
					pFile,
					colFore,
					colBack,
					bLf,
					iMargin,
					bSpace
				);
#ifndef RELEASE_CGI
				fclose( pFile );
#endif
			}
		}
		delete [] inputstring;
	}

	return( 0 );
}
